#  ICBMsim ollexxl@live.se 20130507-
# v.3 Read infile with one year of varying re
# v. 2 20130509 With new iter variable and example on changing re
# ICBM as simulation with driving variables
#  20130509 Gives same values as differential
# equation version, but not fully tested
#Read re file and set names

News=read.table("Ult1970.txt")#Read the infile
 Date=News[,1];Day=News[,2];Temp=News[,3];Prec=News[,4];
Et0=News[,5];re=News[,6]

#counting days
iter <- max(Day) 
# Parameters & state equations, see also www.oandren.com
# Change i, re and h and set inital Y and O

#Create data, here re read from file

#re <- c(1.0,1.0,1.0,1.0,1.0,1.5,1.5,1.5,1.5,0.9,0.9,0.9,0.9,1.0,
1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.5,1.0,1.0,1.0,1.0,1.0,1.0,1.0) 
#i <- c(0.2,0.2,0.2,0.2,0.2)
#re <- rep(1,iter)
re <- re/365 #Annual re to daily
i <- rep(0,iter) #input only on 1 Jan, from autumn
i[1] <- 0.2
h <- rep(0.125,iter)
kY <- rep(0.8,iter)  
kO <- rep(0.00605,iter)  
Y0 <- 0.25 
O0 <- 4.16 
Y <- rep(0,iter) #empty Y
O <- rep(0,iter) #empty O
Tot <- rep(0,iter)

time <- seq(1,iter) #start time and fill vector
Y[1]=Y0 #First iter
O[1]=O0
Tot[1]= Y0+O0

#allpars=cbind(t,O,Y,Tot,re,i,kY,kO,h,Y0,O0,Oss,Yss)
#print(allpars)

# Y,O difference equations

#Y[t]=(Y[t-1]+i[t-1]-kY[t]*re[t]*Y[t-1])
#O[t]=(O[t-1]+(h[t]*kY[t]*re[t]*Y[t-1])-(kO[t]*re[t]*O[t-1]))


#loop, note starts at 2 since initial value
 
for (t in 2:iter) {
	Y[t]=(Y[t-1]+i[t-1]-kY[t-1]*re[t]*Y[t-1]);
	if(Y[t]<0) {
		Y[t]=0
		};
	O[t]=(O[t-1]+(h[t]*kY[t]*re[t]*Y[t-1])-(kO[t]*re[t]*O[t-1]));
	Tot[t]=Y[t]+O[t];

	cat(t,Y[t],O[t],Tot[t],"\n");
}

plot (time,Tot,type='l',col='red',ylim=c(0,10),lwd='3', main = bquote(ICBMsim_Tot_O_mass))
#lines (time,Y,type='l',lwd='3',col='blue')
lines (time,O,type='l',lwd='3',col='black')
windows()
plot(Day,re,type='l',lwd='3',col='black',main = bquote(Ult1970_file_daily_re))
reMean <- mean(re) 
reMean <- rep(reMean,iter)
lines (time,reMean,type='l',lwd='3',col='red',sub = bquote(Average_0.95))




